// Trend Manager.mq4
// Based on indicator sold at traderstradingsystem.com

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Blue
#property indicator_color4 Red

extern int TM_Period = 7;
extern int TM_Shift = 2;

double SpanA_Buffer[];
double SpanB_Buffer[];
double AFill_Buffer[];
double BFill_Buffer[];

int a_begin;

int init()
{
   a_begin=TM_Shift;
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(0,SpanB_Buffer);
   SetIndexDrawBegin(0,TM_Period+a_begin-1);
   SetIndexLabel(0,"TM_Period_A");
   
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(1,SpanA_Buffer);
   SetIndexDrawBegin(1,TM_Period+a_begin-1);
   SetIndexLabel(1,"TM_Period_B");
   
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(2,AFill_Buffer);
   SetIndexDrawBegin(2,TM_Period+a_begin-1);
   SetIndexLabel(2,"TM_Period_AFill");
   
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(3,BFill_Buffer);
   SetIndexDrawBegin(3,TM_Period+a_begin-1);
   SetIndexLabel(3,"TM_Period_BFill");
   
   return(0);
}

int start()
{
   int    i,k;
   int    counted_bars=IndicatorCounted();
   double high,low,price;

   if(Bars<=TM_Period) return(0);
   if(counted_bars<1)
   {
      for(i=1;i<=TM_Period;i+=2) 
      {
         SpanA_Buffer[Bars-i]=0;
         SpanB_Buffer[Bars-i]=0;
      }
   }

   i=Bars-TM_Period;
   if(counted_bars>TM_Period) i=Bars-counted_bars-1;
   while(i>=0)
   {
      high=High[iHighest(NULL,0,MODE_HIGH,2,i)];
      low=Low[iLowest(NULL,0,MODE_LOW,2,i)]; 
      k=i-2+(TM_Period*2);
      while(k>=i)
      {
         price=High[iHighest(NULL,0,MODE_HIGH,2,k)];
         if(high<price) high=price;
         price=Low[iLowest(NULL,0,MODE_LOW,2,k)];
         if(low>price)  low=price;
         k-=2;
      }
      SpanA_Buffer[i]  = (high+low)/2.0;
      SpanB_Buffer[i]  = SpanA_Buffer[i+(TM_Shift*2)];
      AFill_Buffer[i-1] = SpanA_Buffer[i];
      BFill_Buffer[i-1] = SpanB_Buffer[i];
      i-=2;
   }

   return(0);
}